package com.winhc.max.compute.graph.util;

import com.google.common.reflect.TypeToken;
import com.google.gson.Gson;

import java.util.Collections;
import java.util.List;
import java.util.Map;

/**
 * @author: XuJiakai
 * 2023/2/10 16:38
 */
public class JsonUtils {

    public static List<String> parseListStr(Gson gson, String jsonArrayStr) {
        List<String> list = gson.fromJson(jsonArrayStr, new TypeToken<List<String>>() {
        }.getType());
        if (list == null) {
            return Collections.emptyList();
        }
        return list;
    }

    public static List<Map<String, String>> parseListStrByMap(Gson gson, String jsonArrayStr) {
        List<Map<String, String>> list = gson.fromJson(jsonArrayStr, new TypeToken<List<Map<String, String>>>() {
        }.getType());
        if (list == null) {
            return Collections.emptyList();
        }
        return list;
    }


    public static void main(String[] args) {
        Gson gson = new Gson();
        List<Map<String, String>> maps = parseListStrByMap(gson, "[{\"name\":\"汤玲玲\",\"id\":\"p4b9f3db9b6f462e5008497107e853095\",\"type\":1,\"deleted\":0}]");
        System.out.println(maps);
    }
}
