package com.winhc.max.compute.graph.util;

import com.aliyun.odps.io.NullWritable;
import com.aliyun.odps.io.Text;
import com.aliyun.odps.io.Writable;
import com.aliyun.odps.io.WritableRecord;
import lombok.SneakyThrows;

import java.io.IOException;

/**
 * @author: XuJiakai
 * 2022/7/11 14:30
 */
public class WritableRecordExtensions {


    @SneakyThrows
    public static <T extends Writable> T getOrNullInstance(WritableRecord writableRecord, String filedName, Class<T> type) throws IOException {
        Writable writable = writableRecord.get(filedName);
        if (writable == null || writable.equals(NullWritable.get())) {
            return type.newInstance();
        } else {
            return ((T) writable);
        }
    }

    @SneakyThrows
    public static <T extends Writable> T getOrNull(WritableRecord writableRecord, String filedName, Class<T> type) throws IOException {
        Writable writable = writableRecord.get(filedName);
        if (writable == null || writable.equals(NullWritable.get())) {
            return null;
        } else {
            return ((T) writable);
        }
    }


    public static Text getTextOrNull(WritableRecord writableRecord, String filedName) throws IOException {
        return getOrNullInstance(writableRecord, filedName, Text.class);
    }
}
